import * as tslib_1 from "tslib";
import * as React from "react";
import { Button } from "./Button";
import { FocusWithin } from '../../FocusWithin';
import { Icon } from '../../Icon';
var buttonId = 1;
var DropdownButton = /** @class */ (function (_super) {
    tslib_1.__extends(DropdownButton, _super);
    function DropdownButton(props) {
        var _this = _super.call(this, props) || this;
        _this.buttonElement = React.createRef();
        _this.expand = function (expanded) {
            _this.setState({ expanded: expanded });
            return expanded;
        };
        _this.renderCallout = function () {
            return _this.props.onRenderDropdown(_this, _this.state.id, _this.props.anchorElement ? _this.props.anchorElement : !_this.props.anchorPoint ? _this.buttonElement.current : undefined, _this.props.anchorOffset || { horizontal: 0, vertical: 0 }, _this.props.anchorOrigin || { horizontal: "end" /* end */, vertical: "end" /* end */ }, _this.props.anchorPoint, _this.props.dropdownOrigin || { horizontal: "end" /* end */, vertical: "start" /* start */ });
        };
        _this.onBlur = function () {
            _this.expand(false);
        };
        _this.onClick = function (event) {
            if (!event.defaultPrevented) {
                if (!_this.state.expanded) {
                    _this.expand(!_this.state.expanded);
                }
                event.preventDefault();
            }
        };
        _this.onKeyDown = function (event) {
            if (!event.defaultPrevented) {
                if (!_this.props.disabled) {
                    if (!_this.props.ignoreArrowDown && event.which === 40 /* DownArrow */) {
                        _this.expand(true);
                        event.preventDefault();
                    }
                    else if (event.which === 27 /* Escape */) {
                        _this.expand(false);
                        event.preventDefault();
                    }
                }
            }
        };
        _this.state = {
            expanded: false,
            id: _this.props.id || "dropdown-button-" + buttonId++
        };
        return _this;
    }
    DropdownButton.prototype.render = function () {
        var _this = this;
        // We disable the tooltip when we are expanded. Make sure we dont remove it
        // from the component tree, this causes the button element to get regenerated
        // and focus wont return.
        return (React.createElement(FocusWithin, { onBlur: this.onBlur }, function (focusStatus) { return (React.createElement("div", { ref: _this.buttonElement, className: "bolt-dropdown-button", onBlur: focusStatus.onBlur, onFocus: focusStatus.onFocus, onKeyDown: _this.onKeyDown },
            React.createElement(Button, tslib_1.__assign({}, _this.props, { ariaControls: _this.state.expanded ? _this.state.id : undefined, ariaExpanded: _this.state.expanded, ariaHasPopup: true, className: _this.props.hideDropdownIcon && "icon-only", onClick: _this.onClick, tooltipProps: _this.props.tooltipProps ? Object.assign({}, _this.props.tooltipProps, { disabled: _this.state.expanded }) : undefined }), !_this.props.hideDropdownIcon && Icon({ key: "dropdown-icon", className: "icon-right", iconName: "ChevronDown" })),
            _this.state.expanded && _this.buttonElement.current && _this.renderCallout())); }));
    };
    return DropdownButton;
}(React.Component));
export { DropdownButton };
