import * as tslib_1 from "tslib";
import "../../Core/core.scss";
import "../../Common.scss";
import "./Checkbox.scss";
import * as React from "react";
import { ObservableLike } from '../../Core/Observable';
import { FocusZoneContext } from '../../FocusZone';
import { Icon } from '../../Icon';
import { Tooltip } from '../../TooltipEx';
import { css } from '../../Util';
var checkboxId = 1;
var Checkbox = /** @class */ (function (_super) {
    tslib_1.__extends(Checkbox, _super);
    function Checkbox(props) {
        var _this = _super.call(this, props) || this;
        _this.onCheckChange = function (checked) {
            _this.forceUpdate();
        };
        _this.onClick = function (event) {
            _this.onChange(event);
        };
        _this.onKeyDown = function (event) {
            if (!event.defaultPrevented) {
                if (event.which === 32 /* Space */ || event.which === 13 /* Enter */) {
                    _this.onChange(event);
                    event.preventDefault();
                }
            }
        };
        _this.onChange = function (event) {
            if (_this.props.onChange) {
                _this.props.onChange(event, !ObservableLike.getValue(_this.props.checked));
            }
        };
        _this._labelId = "checkbox-" + checkboxId++ + "-label";
        return _this;
    }
    Checkbox.prototype.render = function () {
        var _this = this;
        var checked = this.props.checked && ObservableLike.getValue(this.props.checked);
        var _a = this.props, disabled = _a.disabled, label = _a.label, labelId = _a.labelId, tooltipProps = _a.tooltipProps;
        return (React.createElement(FocusZoneContext.Consumer, null, function (zoneContext) {
            var checkbox = (React.createElement("div", { className: css(_this.props.className, "bolt-checkbox", checked && "checked", disabled ? "disabled" : "enabled", "bolt-focus-treatment", label && "labelled"), tabIndex: !disabled && !_this.props.excludeTabStop ? 0 : undefined, onClick: !disabled ? _this.onClick : undefined, "data-focuszone": !disabled && !_this.props.excludeFocusZone ? zoneContext.focuszoneId : undefined, onKeyDown: _this.onKeyDown, role: _this.props.role || "checkbox", "aria-checked": checked, "aria-label": _this.props.ariaLabel, "aria-labelledby": _this.props.ariaLabelledBy || labelId || (label && _this._labelId) },
                React.createElement("div", { className: css("bolt-checkmark", "flex-row") }, Icon({ iconName: "CheckMark" })),
                label && (React.createElement("div", { className: "bolt-checkbox-label", id: labelId || _this._labelId }, label)),
                _this.props.children));
            if (tooltipProps) {
                checkbox = React.createElement(Tooltip, tslib_1.__assign({}, tooltipProps), checkbox);
            }
            return checkbox;
        }));
    };
    Checkbox.prototype.componentDidMount = function () {
        ObservableLike.subscribe(this.props.checked, this.onCheckChange);
    };
    Checkbox.prototype.componentWillUnmount = function () {
        ObservableLike.unsubscribe(this.props.checked, this.onCheckChange);
    };
    return Checkbox;
}(React.Component));
export { Checkbox };
