import "../../Core/core.scss";
import "../../Common.scss";
import * as React from "react";
import { IFocusWithin, IFocusWithinProps } from "./FocusWithin.Props";
export declare class FocusWithin extends React.Component<IFocusWithinProps> implements IFocusWithin {
    private focusTimeout;
    private focusCount;
    private focus;
    render(): JSX.Element;
    /**
     * unmount should called to prevent future events from being propagated to the
     * container and stop monitoring focus changes. This should be called if
     * components are in the process of unmounting.
     */
    componentWillUnmount(): void;
    /**
     * hasFocus returns true if the focus is contained within the focus component
     * hierarchy. This includes portals, the element may or may not
     * be a direct descendant of the focus component in the DOM structure.
     */
    hasFocus(): boolean;
    /**
     * onBlur method that should be attached to the onBlur handler of the
     * continers root element.
     */
    private onBlur;
    /**
     * onFocus method that should be attached to the onFocus handler of the
     * continer's root element.
     */
    private onFocus;
}
