import "../../Core/core.scss";
import "../../Common.scss";
import * as React from "react";
import { IIntersectionProps } from "./Intersection.Props";
export interface IIntersectionContext {
    getScrollTop: () => number;
    observe: (element: HTMLElement) => void;
    register: (callback: IntersectionObserverCallback) => void;
    unobserve: (element: HTMLElement) => void;
    unregister: (callback: IntersectionObserverCallback) => void;
}
declare class IntersectionContextImpl implements IIntersectionContext {
    scrollTop: number;
    private callbacks;
    private observer?;
    private pending;
    connect(root: HTMLElement, rootMargin?: string): void;
    disconnect(): void;
    getScrollTop(): number;
    observe(element: HTMLElement): void;
    register(callback: IntersectionObserverCallback): void;
    unobserve(element: HTMLElement): void;
    unregister(callback: IntersectionObserverCallback): void;
    private onIntersect;
}
export declare const IntersectionContext: React.Context<IIntersectionContext>;
export declare class Intersection extends React.Component<IIntersectionProps, IIntersectionContext> {
    state: IntersectionContextImpl;
    private rootElement;
    constructor(props: Readonly<IIntersectionProps>);
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
}
export {};
