import "../../Core/core.scss";
import "../../Common.scss";
import "./List.scss";
import * as React from "react";
import { FocusZoneDirection } from '../../FocusZone';
import { IEventDispatch } from '../../Utilities/Dispatch';
import { IItemProvider } from '../../Utilities/Provider';
import { IList, ISimpleListCell, IListProps, ISimpleListProps } from "./List.Props";
export interface IListState<T> {
    eventDispatch: IEventDispatch;
    firstPage: number;
    focusIndex: number;
    itemProvider: IItemProvider<T>;
    lastPage: number;
    maxPage: number;
    pageSize: number;
    providerVersion: number;
    renderedRows: Array<JSX.Element | null>;
    rowCount: number;
    rowHeight: number;
    rows: T[];
    scrollTop: number;
}
export declare class List<T> extends React.Component<IListProps<T>, IListState<T>> implements IList<T> {
    static defaultProps: {
        columns: number;
        focuszoneProps: {
            direction: FocusZoneDirection;
        };
        initialPageCount: number;
        role: string;
    };
    static getDerivedStateFromProps<T>(props: Readonly<IListProps<T>>, state: Readonly<IListState<T>>): Partial<IListState<T>> | null;
    private intersectionContext;
    private listElement;
    private spacerElements;
    private pageDetails;
    private firstFocusPage;
    private lastFocusPage;
    constructor(props: Readonly<IListProps<T>>);
    render(): JSX.Element;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    getFocusIndex(): number;
    itemFromPoint(clientX: number, clientY: number): Promise<T | undefined> | T | undefined;
    indexFromPoint(clientX: number, clientY: number): number;
    private onDispatch;
    private onDoubleClick;
    private onFocusItem;
    private onKeyDown;
    private onActivate;
    private onSelect;
    private renderPage;
    private renderSpacer;
    private onIntersect;
    private setPageElement;
    private setSpacerElement;
}
export declare class ScrollableList<T> extends React.Component<IListProps<T>> implements IList<T> {
    private list;
    render(): JSX.Element;
    getFocusIndex(): number;
    indexFromPoint(clientX: number, clientY: number): number;
}
export declare class SimpleList extends React.Component<ISimpleListProps> {
    render(): JSX.Element;
    private onRenderListItem;
}
export declare function renderListCell(listCell: ISimpleListCell | string | number): JSX.Element;
