import * as React from "react";
import { MenuButton } from '../../Menu';
import { css } from '../../Util';
import * as Resources from '../../Resources.Widgets';
var ColumnMore = /** @class */ (function () {
    function ColumnMore(menuProvider) {
        var _this = this;
        this.id = "_more";
        this.width = 32;
        this.onRenderCell = function (rowIndex, columnIndex, tableColumn, listItem) {
            return (React.createElement("td", { key: "col-more", className: css("bolt-table-cell bolt-list-cell", "col-" + columnIndex), "data-column-index": columnIndex },
                React.createElement("div", { className: "bolt-table-cell-content-reveal bolt-table-cell-content flex-row justify-center" },
                    React.createElement(MenuButton, { className: "bolt-table-button-more", hideDropdownIcon: true, iconProps: { iconName: "MoreVertical" }, ignoreArrowDown: true, subtle: true, excludeTabStop: true, tooltipProps: { text: Resources.MoreTooltip }, contextualMenuProps: { menuProps: _this.menuProvider(listItem) } }))));
        };
        this.onRenderHeaderCell = function (columnIndex, tableColumn) {
            return (React.createElement("td", { key: "col-more", className: css(tableColumn.headerClassName, "bolt-table-header-cell bolt-table-header-cell-empty", "col-header-" + columnIndex), "data-column-index": columnIndex }));
        };
        this.menuProvider = menuProvider;
    }
    return ColumnMore;
}());
export { ColumnMore };
