/// <reference types="react" />
import { ITable, ITableProps, ITableColumn } from "./Table.Props";
import { IBehavior } from '../../Utilities/Behavior';
import { EventDispatch } from '../../Utilities/Dispatch';
/**
 * ColumnSelect is used to draw the selection for the given row.
 */
export declare class ColumnSelect implements ITableColumn<{}>, IBehavior<ITableProps<{}>, ITable<{}>> {
    id: string;
    width: number;
    private itemProvider;
    private allSelected;
    private selection?;
    initialize: (props: ITableProps<{}>, table: ITable<{}>, eventDispatch: EventDispatch) => void;
    onRenderCell: (rowIndex: number, columnIndex: number, listColumn: ITableColumn<{}>, listItem: any) => JSX.Element;
    onRenderHeaderCell: (columnIndex: number, listColumn: ITableColumn<{}>, focuszoneId: string) => JSX.Element;
    private toggleSelectAll;
    private onChangeHeader;
    private onKeyDown;
    private onCheckboxMouseDown;
    private onSelectionChange;
}
