import * as tslib_1 from "tslib";
import "../../../Core/core.scss";
import "../../../Common.scss";
import * as React from "react";
import * as DateUtil from '../../../Utilities/Date';
import { Time } from "../Time/Time";
import * as Resources from '../../../VSS.Resources.VSSUI';
import { format } from '../../../Core/Util/String';
var Duration = /** @class */ (function (_super) {
    tslib_1.__extends(Duration, _super);
    function Duration(props) {
        var _this = _super.call(this, props) || this;
        _this.getTimeString = function () {
            return DateUtil.duration(_this.props.startDate, _this.props.endDate);
        };
        /**
         * Returns time in milliseconds for next refresh.
         *
         * @return A number indicating time to refresh in milliseconds
         */
        _this.getNextInterval = function () {
            return Duration.durationNextInterval(_this.props.startDate, _this.props.endDate);
        };
        _this.state = {
            tooltipString: format(Resources.Started, DateUtil.tooltipString(_this.props.startDate))
        };
        return _this;
    }
    Duration.prototype.render = function () {
        return (React.createElement(Time, { tooltipString: this.state.tooltipString, getTimeString: this.getTimeString, getNextInterval: this.getNextInterval }));
    };
    /**
     * Returns time in milliseconds for next refresh.
     *
     * @return A number indicating time to refresh in milliseconds
     */
    Duration.durationNextInterval = function (startDate, endDate, now) {
        if (!endDate) {
            if (!now) {
                endDate = new Date();
            }
            else {
                endDate = now;
            }
            // Getting the difference in seconds between now and the specified date
            var diff = endDate.getTime() - startDate.getTime();
            var interval = DateUtil.minute;
            if (diff < DateUtil.day) {
                interval = DateUtil.second;
            }
            else {
                interval = DateUtil.minute - (diff % DateUtil.minute);
            }
            return interval;
        }
        else {
            return -1;
        }
    };
    return Duration;
}(React.Component));
export { Duration };
