import * as tslib_1 from "tslib";
import "../../../Core/core.scss";
import "../../../Common.scss";
import "./Time.scss";
import * as React from "react";
import { TooltipHost } from '../../../Tooltip';
var Time = /** @class */ (function (_super) {
    tslib_1.__extends(Time, _super);
    function Time(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            output: _this.props.getTimeString()
        };
        return _this;
    }
    Time.prototype.render = function () {
        return (React.createElement("div", { className: "bolt-time-item" },
            React.createElement(TooltipHost, { content: this.props.tooltipString, calloutProps: {
                    /*Calculating tooltip width as it is different for Ago and Duration component*/
                    calloutWidth: Math.round(this.props.tooltipString.length * 6.66)
                }, delay: 1 },
                React.createElement("span", null, this.state.output))));
    };
    Time.prototype.componentDidMount = function () {
        this.setNextRefresh();
    };
    Time.prototype.componentWillUnmount = function () {
        if (this.timerId) {
            clearTimeout(this.timerId);
        }
    };
    Time.prototype.setNextRefresh = function () {
        var _this = this;
        var t = this.props.getNextInterval();
        if (t !== -1) {
            this.timerId = setTimeout(function () {
                _this.setState({
                    output: _this.props.getTimeString()
                });
                _this.setNextRefresh();
            }, t);
        }
    };
    return Time;
}(React.Component));
export { Time };
