export interface IItemProvider<T> {
    getCount: () => number;
    getItem: (index: number) => Promise<T | undefined> | T | undefined;
    getPosition: (index: number) => number;
    getTotal: () => number;
    getVersion: () => number;
}
export declare class ArrayItemProvider<T> implements IItemProvider<T> {
    protected items: T[];
    constructor(items: T[]);
    getCount(): number;
    getItem(index: number): Promise<T | undefined> | T | undefined;
    getPosition(index: number): number;
    getTotal(): number;
    getVersion(): number;
}
