import { IObservable, Observable } from '../Core/Observable';
export interface ISelectionRange {
    beginIndex: number;
    endIndex: number;
}
export interface ISelection extends IObservable<ISelectionRange[], "select" | "unselect"> {
    multiSelect: boolean;
    selectedCount: number;
    getSelection(): Readonly<ISelectionRange[]>;
    selected(index: number): boolean;
    clear(): void;
    select(index: number, count?: number, merge?: boolean): void;
    unselect(index: number, count?: number): void;
    lock(): void;
    unlock(): void;
}
export interface IHasSelection {
    selection?: ISelection;
}
export interface ISelectableUI {
    getFocusIndex(): number;
    indexFromPoint(clientX: number, clientY: number): number;
}
export interface IIndexed {
    index: number;
}
export declare class Selection extends Observable<ISelectionRange[], "select" | "unselect"> implements ISelection {
    multiSelect: boolean;
    selectedCount: number;
    private selectedRanges;
    private lockCount;
    constructor(multiSelect?: boolean);
    clear(): void;
    getSelection(): Readonly<ISelectionRange[]>;
    selected(index: number): boolean;
    select(index: number, count?: number, merge?: boolean): void;
    unselect(index: number, count?: number): void;
    lock(): void;
    unlock(): void;
}
